#include "cabecera.h"
/**************************************************************************
   Funcin:          menu

   Descripcin:      menu inicial que discrimina entre clientes,equipos y facturas

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu()
{
	int opc;
	system("clear");
	printf("\n\t\tMENU PRINCIPAL");	
	printf("\n\n\t1.- Clientes");
	printf("\n\t2.- Equipos");
	printf("\n\t3.- Facturas");
	printf("\n\t4.- Salir del programa");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_clientes

   Descripcin:      menu con las funciones de cliente

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_clientes()
{
	int opc;
	system("clear");
	printf("\n\t\tMENU CLIENTES");	
	printf("\n\n\t1.- Anadir clientes");
	printf("\n\t2.- Eliminar clientes");
	printf("\n\t3.- Modificar clientes");
	printf("\n\t4.- Listar cliente");
	printf("\n\t5.- Listar fichero clientes");
	printf("\n\t6.- Volver al menu principal");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_equipos

   Descripcin:      menu con las funciones de equipos

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_equipos()
{
	int opc;
	system("clear");
	printf("\n\t\tMENU EQUIPOS");	
	printf("\n\n\t1.- Anadir equipo");
	printf("\n\t2.- Eliminar equipo");
	printf("\n\t3.- Modificar equipo");
	printf("\n\t4.- Listar fichero equipos");
	printf("\n\t5.- Listar equipo individual");
	printf("\n\t6.- Volver menu principal");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_facturas

   Descripcin:      menu con las funciones de facturas

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_facturas()
{
	int opc;
	system("clear");
	printf("\n\t\tMENU FACTURAS");	
	printf("\n\n\t1.- Anadir factura");
	printf("\n\t2.- Eliminar factura por numero");
	printf("\n\t3.- Eliminar factura por cliente");
	printf("\n\t4.- Modificar factura");
	printf("\n\t5.- Listar fichero facturas");
	printf("\n\t6.- Listar facturas de un cliente");	
	printf("\n\t7.- Volver al menu principal");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_modificar_equipo()

   Descripcin:      menu para la eleccion del campo a modificar en la estructura
                     equipo.

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_modificar_equipo()
{
	int opc;
	
	system("clear");
	printf("\n\t\tMENU MODIFICAR EQUIPOS");	
	printf("\n\n\tElija el campo a modificar :");
	printf("\n\n\t1.- Modificar codigo");
	printf("\n\t2.- Modificar nombre");
	printf("\n\t3.- Modificar tipo de procesador");
	printf("\n\t4.- Modificar memoria ");
	printf("\n\t5.- Modificar unidades en stock");
	printf("\n\t6.- Modificar precio ");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_listar

   Descripcin:      menu para la eleccion de listado por pantalla o a fichero de
   		     texto

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_listar()
{
     int opc;

     system("clear");
     printf("\n\t\tMENU LISTAR");	
     printf("\n\n\t1.-Listar por pantalla");
     printf("\n\t2.-Listar por fichero de texto");
     printf("\n\t3.-Volver al menu anterior ");
     printf("\n\n\tIntroduzca opcion ==> ");

     scanf("%d",&opc);
     fflush(stdin);
     return(opc);
}
/**************************************************************************
   Funcin:          menu_modificar_cliente

   Descripcin:      menu para la eleccion del campo a modificar en la estructura
                     cliente.

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_modificar_cliente()
{
	int opc;
	
	system("clear");
	printf("\n\t\tMENU MODIFICAR CLIENTES");	
	printf("\n\n\tElija el campo a modificar :");
	printf("\n\n\t1.- Modificar nombre");
	printf("\n\t2.- Modificar apellido 1");
	printf("\n\t3.- Modificar apellido 2");
	printf("\n\t4.- Modificar direccion");
	printf("\n\t5.- Modificar nif");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          menu_modificar_factura

   Descripcin:      menu para la eleccion del campo a modificar en la estructura
                     factura.

   Valor devuelto:   int opc --> Eleccion del usuario

   Llamada a funciones:  ninguna                        	**********/
int menu_modificar_factura()
{
	int opc;
	
	system("clear");
	printf("\n\t\tMENU MODIFICAR FACTURA");	
	printf("\n\n\tElija el campo a modificar :");
	printf("\n\n\t1.- Modificar Fecha");
	printf("\n\t2.- Modificar unidades vendidas");
	printf("\n\t3.- Modificar Descuento");
	printf("\n\t4.- Modificar Importe");
	printf("\n\n\tIntroduzca opcion ==>");
	
	scanf("%d",&opc);
	fflush(stdin);
	return(opc);
}
/**************************************************************************
   Funcin:          abrir_fichero
   Descripcin:      Abre un fichero que le pasemos ,y si no existe lo crea sin
   		     dar fallo,abriendolo en modo 'wb',y volviendolo a abrir en
   		     el modo que le hemos pasado

   Parametros entrada: char *modo--> cadena con el modo que queremos abrir el fichero
   		       char*nombre_fichero--> cadena con el nombre del fichero
   		       FILE**f_binario --> ptr a fichero pasado por referencia
   		
   Valor devuelto:   ninguno

   Llamada a funciones: int f_error(int)                       	**********/
void abrir_fichero(FILE **f_binario,char *modo,char *nombre_fichero)
{
	if((*f_binario=fopen(nombre_fichero,modo))==NULL)/* No existe */
        {
        	f_error(-6);
               	*f_binario=fopen(nombre_fichero,"wb"); /* lo creamos*/
                fclose(*f_binario);           /*lo cerramos*/
                *f_binario=fopen(nombre_fichero,modo);/*y lo abrimos en nuestro "modo"*/
 	}
}
/**************************************************************************
   Funcin:          sacar_pantalla_eqipo

   Descripcin:      Imprime en pantalla una estructura de tipo equipo

   Parametros entrada: equipo dato --> estructura que queremos imprimir
   		
   Valor devuelto:   ninguno

   Llamada a funciones: 				******************/

void sacar_pantalla_equipo(equipo dato)/*si*/
{
	printf("\n\n\tCodigo : %d ",dato.codigo);
	printf("\n\tNombre   : %s",dato.nombre);
	printf("\n\tTipo de procesador : %s",dato.procesador);
	printf("\n\tTamano memoria : %d",dato.memoria);
	printf("\n\tUnidades stock : %d",dato.stock);
	printf("\n\tPrecio : %.0f",dato.precio);
}
/**************************************************************************
   Funcin:          sacar_pantalla_cliente

   Descripcin:      Imprime en pantalla una estructura de tipo cliente

   Parametros entrada: cliente dato --> estructura que queremos imprimir
   		
   Valor devuelto:   ninguno

   Llamada a funciones: 				******************/

void sacar_pantalla_cliente(cliente dato)
{
	printf("\n\n\tNif : %s ",dato.nif);
	printf("\n\tNombre   : %s",dato.nombre);
	printf("\n\tApellid 1 : %s",dato.apellido1);
	printf("\n\tApellido2 : %s",dato.apellido2);
	printf("\n\tDireccion : %s",dato.direccion);
}
/**************************************************************************
   Funcin:          sacar_pantalla_factura

   Descripcin:      Imprime en pantalla una estructura de tipo factura

   Parametros entrada: factura dato --> estructura que queremos imprimir
   		
   Valor devuelto:   ninguno

   Llamada a funciones: void sacar_pantalla_equipo()
   			void sacar_pantalla_cliente()       *************/
void sacar_pantalla_factura(factura dato)/*si*/
{
	system("clear");
	printf("\n\n\tNumero : %d ",dato.numero_fac);
	printf("\n\tFecha : %s",dato.fecha);
	printf("\n\n\t\tCLIENTE : ");
	sacar_pantalla_cliente(dato.reg_cliente);
	printf("\n\n\t\tEQUIPO :");
	sacar_pantalla_equipo(dato.reg_equipo);
	printf("\n\n\tDescuento : %d",dato.descuento);
	printf("\n\tImporte : %.0f",dato.importe);
}
/**************************************************************************
   Funcin:          lee_equipo_teclado()

   Descripcin:      Lee del teclado una estructura de tipo equipo

   Parametros entrada: int codigo_metido-->  codigo del equipo que vamos a 'rellenar'
   		
   Valor devuelto:   equipo dato

   Llamada a funciones:    intr_cadena()
   			   intr_entero()
   			   intr_float()		       *************/
equipo lee_equipo_teclado(int codigo_metido)/*si*/
{
	equipo dato;

	system("clear");          	
	dato.codigo=codigo_metido;
	intr_cadena(dato.nombre,"Nombre");
	intr_cadena(dato.procesador,"Tipo de procesador");
	intr_entero(&dato.memoria,"Tamano memoria");
	intr_entero(&dato.stock,"Unidades stock");
	intr_float(&dato.precio,"Precio");
	return(dato);
}
/**************************************************************************
   Funcin:          lee_cliente_teclado()

   Descripcin:      Lee del teclado una estructura de tipo cliente

   Parametros entrada: char*nif_metido--> nif del cliente que vamos a 'rellenar'
   		
   Valor devuelto:   cliente dato

   Llamada a funciones:    intr_cadena()   		    *************/
cliente lee_cliente_teclado(char *nif_metido)
{
	cliente dato;

	system("clear");          	
	strcpy(dato.nif,nif_metido);
	intr_cadena(dato.nombre,"Nombre");
	intr_cadena(dato.apellido1,"Apellido 1");
	intr_cadena(dato.apellido2,"Apellido 2");
	intr_cadena(dato.direccion,"Direccion");
	return(dato);
}