#include "cabecera.h"

/**************************************************************************
   Funcin:          anadir_factura

   Descripcin:      Aade factura al fichero de facturas ,controlando la existencia
                     del equipo vendido y del comprador.Asigna n de factura...
   		
   parametros recibidos:char *f_equipos--> nombre fichero equipos
                        char*f_facturas--> nombre fichero facturas
                        char*f_clientes--> nombre fichero clientes

   Llamada a funciones:  abrir_fichero
   	                 busca_equipo
   	                 busca_cliente
   			 f_error
   			 sacar_pantalla_equipo
   			 sacar_pantalla_cliente
   			                         	**********/

void anadir_factura(char *f_clientes,char *f_equipos,char *f_facturas)
{
	FILE * ptr_clientes,*ptr_equipos,*ptr_facturas;
	int cod_pedido,n_ventas;
	char nif_pedido[10];
	equipo vendido;
	cliente comprador;
	factura procesada;
	
        abrir_fichero(&ptr_clientes,"rb",f_clientes);
        abrir_fichero(&ptr_equipos,"r+b",f_equipos);
        abrir_fichero(&ptr_facturas,"r+b",f_facturas);
	                                                          	
	intr_entero(&cod_pedido,"codigo del equipo");
        vendido=busca_equipo(ptr_equipos,cod_pedido);

        if(f_error(vendido.codigo))
        {
                sacar_pantalla_equipo(vendido);
                pausa();


                intr_cadena(nif_pedido,"nif del cliente");
                comprador=busca_cliente(ptr_clientes,nif_pedido);

                if(f_error(atoi(comprador.nif)))
                {
                     sacar_pantalla_cliente(comprador);
                     pausa();

                     intr_entero(&n_ventas,"N de equipos");

                     if(n_ventas==vendido.stock)
                           borrar_equipo(&ptr_equipos,vendido.codigo,f_equipos);
                           /*borramos el registro del fichero de equipos*/
                           /*la funcion nos devuelve abierto en forma 'r+b'*/

                             /*Ahora rellenamos campos de la estructura factura*/
                     fseek(ptr_facturas,-1*sizeof(factura),SEEK_END);
                             /*apuntamos al ultimo registro del fichero de facturas*/
                             /*lo leemos para averiguar el n de factura anterior*/

                     if(fread(&procesada,sizeof(factura),1,ptr_facturas)==0)
          			procesada.numero_fac=1;/*es la primera factura*/
                     else
                     	procesada.numero_fac++;
                     /*si no es la primera incrementamos en una respecto de la anterior factura*/

                     vendido.stock=n_ventas;/*en campo stock del registro equipo
                     				metemos el numero equipos vendidos*/
                     				
                     procesada.reg_cliente=comprador;/*y copiamos el registro cliente*/
                     procesada.reg_equipo=vendido;/*y equipo en la estructura factura,
                                                 en sus campos correspondientes*/

                     intr_entero(&procesada.descuento,"Descuento");
                     intr_cadena(procesada.fecha,"Fecha");
                     intr_float(&procesada.importe,"Importe");

                     fwrite(&procesada,sizeof(factura),1,ptr_facturas);
                }
        }/**fin 1 'if'**/
        fclose(ptr_facturas);
        fclose(ptr_clientes);
}
/**************************************************************************
   Funcin:          listar_fichero_facturas

   Descripcin:      Lista el fichero de facturas

   parametros recibidos:char *nombre_fichero_binario-->nombre del fichero a listar

   Llamada a funciones:  abrir_fichero
   	                 f_error
   	                 menu_listar
   			 sacar_pantalla_factura                     	**********/

void listar_fichero_facturas(char *nombre_fichero_binario)
{
     int opc;
     char nombre_fichero_texto[10];
     FILE *f_binario,*f_texto;
     factura dato;

     opc=menu_listar();
     abrir_fichero(&f_binario,"rb",nombre_fichero_binario);

     switch(opc)
     {                         /*por pantalla*/
           case 1:while((fread(&dato,sizeof(factura),1,f_binario))!=0)
                  {
           	      sacar_pantalla_factura(dato);
                      pausa();
                  }
           	  break;
                                 /*volcado a fichero de texto*/
           case 2:system("clear");           	
           	  intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");         	
           	  f_texto=fopen(nombre_fichero_texto,"w");

                  while((fread(&dato,sizeof(factura),1,f_binario))!=0)
                  {
           	      fprintf(f_texto,"\nNumero de factura: %d",dato.numero_fac);
           	      fprintf(f_texto,"\n\n\t\tCLIENTE\n\n Nif:%s\nNombre:%s %s %s\nDireccion:%s\n\n",dato.reg_cliente.nif,dato.reg_cliente.nombre,dato.reg_cliente.apellido1,dato.reg_cliente.apellido2,dato.reg_cliente.direccion);
           	      fprintf(f_texto,"\n\n\t\tEQUIPO\n\nCodigo :%d\nNombre:%s\nProcesador:%s\nMemoria:%d\nStock:%d\nPrecio%f\n\n",dato.reg_equipo.codigo,dato.reg_equipo.nombre,dato.reg_equipo.procesador,dato.reg_equipo.memoria,dato.reg_equipo.stock,dato.reg_equipo.precio);
           	      fprintf(f_texto,"\nDescuento : %d",dato.descuento);
           	      fprintf(f_texto,"\nImporte : %.0f",dato.importe);
                  }
                  fclose(f_texto);
                  break;

           case 3:break;

           default :f_error(-3);
     }
     fclose(f_binario);
}
/**************************************************************************
   Funcin:          listar_facturas_cliente

   Descripcin:      Lista las fcaturas de un mismo cliente

   parametros recibidos:char *nombre_fichero_facturas-->nombre del fichero de facturas
                        char *nombre_fichero_clientes--> nombre del fichero de clientes

   Llamada a funciones:  abrir_fichero
   	                 busca_cliente
   	                 f_error
   	                 menu_listar
   	                 busca_factura_dni
   			 sacar_pantalla_factura                     	**********/

void listar_facturas_cliente(char *nombre_fichero_facturas,char *nombre_fichero_cliente)
{
     FILE *f_binario_factura,*f_binario_cliente,*f_texto;
     char dni_pedido[10],nombre_fichero_texto[10];
     int opc;
     cliente comprador;
     factura dato;

     abrir_fichero(&f_binario_factura,"rb",nombre_fichero_facturas);
     abrir_fichero(&f_binario_cliente,"rb",nombre_fichero_cliente);
     intr_cadena(dni_pedido,"Nif cliente");

     comprador=busca_cliente(f_binario_cliente,dni_pedido);

     if(f_error(atoi(comprador.nif)))/*mirara si el dni existe en fichero clientes*/
     {
       	opc=menu_listar();
     	
     	switch(opc)
     	{                          /*pantalla*/
             case 1:dato=busca_factura_dni(f_binario_factura,dni_pedido);
             	    f_error(dato.numero_fac);
                    while(dato.numero_fac!=-7)
                    {
                    	sacar_pantalla_factura(dato);
                    	pausa();
                    	dato=busca_factura_dni(f_binario_factura,dni_pedido);
                    }
	            break;

	     case 2:intr_cadena(nombre_fichero_texto,"Nombre del fichero de salida");
                    f_texto=fopen(nombre_fichero_texto,"w");
                    dato=busca_factura_dni(f_binario_factura,dni_pedido);
             	    f_error(dato.numero_fac);
                    while(dato.numero_fac!=-7)
                    {
                    	fprintf(f_texto,"\nNumero de factura: %d",dato.numero_fac);
           	     	fprintf(f_texto,"\n\n\t\tCLIENTE\n\n Nif:%s\nNombre:%s %s %s\nDireccion:%s\n\n",dato.reg_cliente.nif,dato.reg_cliente.nombre,dato.reg_cliente.apellido1,dato.reg_cliente.apellido2,dato.reg_cliente.direccion);
           	    	fprintf(f_texto,"\n\n\t\tEQUIPO\n\nCodigo :%d\nNombre:%s\nProcesador:%s\nMemoria:%d\nStock:%d\nPrecio%f\n\n",dato.reg_equipo.codigo,dato.reg_equipo.nombre,dato.reg_equipo.procesador,dato.reg_equipo.memoria,dato.reg_equipo.stock,dato.reg_equipo.precio);
           	    	fprintf(f_texto,"\nDescuento : %d",dato.descuento);
           	    	fprintf(f_texto,"\nImporte : %.0f",dato.importe);
                    }
                    fclose(f_texto);
                    break;

             case 3:break;
             default:f_error(-3);
        }
     }
     fclose(f_binario_factura);
     fclose(f_binario_cliente);
}
/**************************************************************************
   Funcin:          busca_factura_numero

   Descripcin:      Busca una factura por su numero,si no encuentra devuelve
                     un -7 el el campo numero_fac de la estructura

   parametros recibidos:FILE *f_binario-->ptr a fichero de fcaturas ,ya abierto
                        int n_fact --> numero de factura buscada

   valor devuelto :   factura dato --> contendra la factura buscada o el ultimo
                               registro con un -7 en el campo numero_fac    **/

factura busca_factura_numero(FILE * f_binario,int n_fact)
{
	factura dato;
	int no_encontrado=0; /**nos indicara si se ha encontrado**/
	
        rewind(f_binario);                 	
	while((fread(&dato,sizeof(factura),1,f_binario))!=0)
   	{
       		if(dato.numero_fac==n_fact)
       		{
       	  		no_encontrado=1;
       	  		break;
       		}
   	}

   	if(no_encontrado==0) /*Lo indicamos fuera de la funcion devolviendo en el */
   		dato.numero_fac=-7; /*numero de factura de la estructura un -7 */

   	return (dato);
}
/**************************************************************************
   Funcin:          busca_factura_dni

   Descripcin:      busca una factura cuyo deudor sea el de un dni deternminado,
                     sino se encuentra devuelve un -7 en el campo numero_fac de la
                     estructura

   parametros recibidos:FILE *f_binario -->ptr a fichero facturas,se le pasara abierto
                        char *dni_cliente--> dni del cliente deudor

   valor devuelto: factura dato --> contendra la factura buscada o el ultimo
                               registro con un -7 en el campo numero_fac    **/

factura busca_factura_dni(FILE * f_binario,char *dni_cliente)
{
	factura dato;
	int no_encontrado=0; /**nos indicara si se ha encontrado**/
                         	
	while((fread(&dato,sizeof(factura),1,f_binario))!=0)
   	{
       		if(strcmp(dato.reg_cliente.nif,dni_cliente)==0)
       		{
       	  		no_encontrado=1;
       	  		break;
       		}
   	}
   	if(no_encontrado==0) /*Lo indicamos fuera de la funcion devolviendo en el */
   		dato.numero_fac=-7; /*numero de factura de la estructura un -7 */

   	return (dato);
}
/**************************************************************************
   Funcin:          eliminar_fcatura_numero

   Descripcin:      Pide numero de fcatura y llama a borrar y a actualizar stock

   parametros recibidos:char *nombre_f_fcaturas -->nombre de fichero de facturas
                        char *nomobre_f_equipos -->nombre de fichero de equipos

   llamada a funciones : abrir_fichero
   			 busca_factura_numero
   			 sacar_pantalla_factura
   			 actualiza_stock
   			 borrar_factura			   *****************/

void eliminar_factura_numero(char *nombre_f_facturas,char *nombre_f_equipos)
{
    factura dato;
    int n_fact;
    char respuesta;
    FILE *f_facturas,*f_equipos;

    intr_entero(&n_fact,"n factura a borrar");
    abrir_fichero(&f_facturas,"r+b",nombre_f_facturas);

    dato=busca_factura_numero(f_facturas,n_fact);

    if(f_error(dato.numero_fac))
    {
    	sacar_pantalla_factura(dato);
    	pausa();
    	printf("\n\n\tDesea borrar este registro ? (S/N)");
    	respuesta=toupper(getchar());
    	
    	if(respuesta='S')
    	{
    	     actualiza_stock(nombre_f_equipos,dato.reg_equipo.stock,dato.reg_equipo.codigo);
    	     borrar_factura(&f_facturas,dato.numero_fac,nombre_f_facturas);
    	}
    }
    fclose(f_facturas);
}
/**************************************************************************
   Funcin:          elimina_factura_cliente

   Descripcin:   Pide dni cliente y llama a borrar_factura y borrar cliente
   		  y actualixzar stock
   		
   parametros recibidos:char *nombre_f_fcaturas -->nombre de fichero de facturas
                        char *nombre_f_equipos -->nombre de fichero de equipos
                        char *nombre_f_clientes -->nombre de fichero de clientes

   llamada a funciones : abrir_fichero
                         busca_cliente
                         f_error
                         sacar_pantalla_cliente
                         borrar_cliente
   			 busca_factura_dni
   			 actualiza_stock
   			 borrar_factura			   *****************/

void eliminar_factura_cliente(char *nombre_f_facturas,char *nombre_f_equipos,char *nombre_f_clientes)
{
    factura dato;
    int n_fact,i;
    char respuesta,nif_cliente[10];
    FILE *f_facturas,*f_equipos,*f_clientes;

    intr_cadena(nif_cliente,"Nif cliente");

    abrir_fichero(&f_clientes,"r+b",nombre_f_clientes);
    dato.reg_cliente=busca_cliente(f_clientes,nif_cliente);

    if(f_error(atoi(dato.reg_cliente.nif)))
    {
      sacar_pantalla_cliente(dato.reg_cliente);
      printf("\n\n\tDesea borrar este registro ? (S/N)");
      respuesta=toupper(getchar());

      if(respuesta='S')
      {
         borrar_cliente(&f_clientes,nif_cliente,nombre_f_clientes);

         abrir_fichero(&f_facturas,"r+b",nombre_f_facturas);
       	
       	 do
    	 {
    	     dato=busca_factura_dni(f_facturas,nif_cliente);
    	     actualiza_stock(nombre_f_equipos,dato.reg_equipo.stock,dato.reg_equipo.codigo);
    	     borrar_factura(&f_facturas,dato.numero_fac,nombre_f_facturas);    	           	

         }while(dato.numero_fac!=-7);

         fclose(f_facturas);
      }
      fclose(f_clientes);
    }

}
/**************************************************************************
   Funcin:          borrar_facturae

   Descripcin:   borra una determinada factura del fichero por el numero de factura
   		     		
   parametros recibidos:char *nombre_fichero_original-->nombre de fichero de facturas
                        FILE ** F_original -->ptr a fichero pasado por referencia
                        		     fichero pasado abierto
                        int n_factura --> numero de la factura a borrar
							   *****************/

void borrar_factura(FILE **f_original,int n_factura,char *nombre_fichero_original)
{
	FILE *temp;
	factura dato;
	
	rewind(*f_original);	
        temp=fopen("temporal","wb");

        while((fread(&dato,sizeof(factura),1,*f_original)!=0))
        {
           if(dato.numero_fac!=n_factura)
        	fwrite(&dato,sizeof(factura),1,temp);
        }
        fclose(*f_original);
        fclose(temp);
        remove(nombre_fichero_original);
        rename("temporal",nombre_fichero_original);

        *f_original=fopen(nombre_fichero_original,"r+b");
}
/**************************************************************************
   Funcin:          modificar_factura

   Descripcin:   Modifica los campos de la estructura factura
   		
   parametros recibidos:char *nombre_f_fcaturas -->nombre de fichero de facturas
                        char *nombre_f_equipos -->nombre de fichero de equipos

   llamada a funciones : abrir_fichero
                         busca_fcatura_numero
                         f_error
                         sacar_pantalla_factura
                         menu_modificar_factura
                         busca_equipo
                         borrar_equipo			   *****************/

void modificar_factura(char *nombre_f_facturas,char *nombre_f_equipos)
{
     int n_factura_modif,n_ventas,opc;
     char respuesta;
     FILE * f_facturas,*f_equipos;
     factura dato;
     equipo vendido;

     intr_entero(&n_factura_modif,"N factura");
     abrir_fichero(&f_facturas,"r+b",nombre_f_facturas);
     dato=busca_factura_numero(f_facturas,n_factura_modif);

     if(f_error(dato.numero_fac))
     {
          do
          {
              sacar_pantalla_factura(dato);
              pausa();
              opc=menu_modificar_factura();
              switch(opc)
              {
                    case 1:intr_cadena(dato.fecha,"Fecha");
                           break;

                    case 2:intr_entero(&n_ventas,"unidades vendidas");
                           abrir_fichero(&f_equipos,"r+b",nombre_f_equipos);
                           vendido=busca_equipo(f_equipos,dato.reg_equipo.codigo);

                           if(vendido.codigo==-1)/*no existe,habiamos terminado existencias*/
                           {
                            	if(n_ventas<dato.reg_equipo.stock)
                            	{
                            	    /*escribimos equipo vendido al final de fichero equipos*/
                            	    dato.reg_equipo.stock=dato.reg_equipo.stock-n_ventas;/*equipos vendidos*/
                            	    fseek(f_equipos,0,SEEK_END);
                            	    fwrite(&dato.reg_equipo,1*sizeof(equipo),1,f_equipos);
                            	    dato.reg_equipo.stock=n_ventas;
                            	}
                            	else
                            	    f_error(-2);
                           }
                           else
                           {
                                if(vendido.stock==n_ventas)
                                {
                                     borrar_equipo(&f_equipos,vendido.codigo,nombre_f_equipos);
                                     dato.reg_equipo.stock=n_ventas;
                                }
                                else if(vendido.stock>n_ventas)
                                     dato.reg_equipo.stock=n_ventas;
                                else
                                     f_error(-2);
                           }
                           fclose(f_equipos);
                           break;
                    case 3:intr_entero(&dato.descuento,"descuento");
                    	   break;
                    case 4:intr_float(&dato.importe,"importe");
                           break;
                    default:f_error(-3);
              }

    	      printf("\n\tDesea modificar mas campos ? (S/N) ");
	      fflush(stdin);
	      respuesta=toupper(getchar());
              system("clear");
          }while(respuesta=='S');

          sacar_pantalla_factura(dato);
          pausa();
          /*escribir fichero fcatura*/
          fseek(f_facturas,-1*sizeof(factura),SEEK_CUR);
          fwrite(&dato,1*sizeof(factura),1,f_facturas);

     }
     fclose(f_facturas);
}