/*********************** Torres de Hanoi ***********************/
#include "cabecera.h"

/* Creada por Jose Mariscal Prieto */
/* ultima modificacion 11-03-2001  */

/* Realizar una funcion recursiva que resuelva el problema de las torres
de Hanoi */

/* Parametros de entrada: un entero con el numero de discos, y 3
caracteres, que son cada una de las puntas a las que hay que ir moviendo
los discos */
/* Parametro de salida: La funcion devuelve un entero que es el numero de
movimientos */

/******* Comienzo de la Funcion Hanoi *******/
int hanoi(int discos, char a, char b, char c)
{
  static int movimientos = 0; /* declaro el contador entero estatico,
  de esta forma mantiene su valor a traves de la funcion recursiva, cosa
  que si no hacemos devolvera como valor 1 siempre */
  
  if (discos > 0) /* hasta que el numero de discos no se haga 0 realiza el
  esquema condicional */
  {
    hanoi(discos-1, a, c, b); /* llamo otra vez a la funcion asi misma */
    /* la posicion 2 pasa a ser la tercera y la posicion 3 la segunda */
    printf("mueve el disco de %c a %c\n", a, c); /* moviendo el disco de la
    posicion 1 a la 2 */
    movimientos++; /* movimiento realizado mas uno */
    hanoi(discos-1, b, a, c); /* Vuelvo a llamar la la funcion sobre si misma */
    /* la posicion 1 pasa a ser la 3 y la 3 pasa a ser la 1 */
  }
  return movimientos; /* devuelvo el numero de movimientos */
}
