#include "principal.h"

/* Funcion Vacio */
/* Es de tipo entero, comprueba si esta el vector vacio, devuelve -1 si lo esta
recibe n entero, que es el numero de personas del vector */

int Vacio(int n)
{
if(n==-1)
	{
	printf("\nNo se ha introducido ninguna persona en la lista.\n");
	printf("Pulse ENTRAR para continuar...\n");
	getchar();
	return -1;
	}
return 1;
}


/* Funcion Menu */
/* es de tipo entero, muestra el menu de opciones y devuelve la opcion elegida*/

int Menu(void)
{
int opc;
do
	{
	system("clear");
	printf("***********************************************************************\n");
	printf("***			      MENU DE OPCIONES	   		    ***\n");
	printf("*** --------------------------------------------------------------- ***\n");
	printf("*** 1. Introduccin de datos		  			    ***\n");
	printf("*** 2. Listado de personas					    ***\n");
        printf("*** 3. Ordenar datos por apellidos                                  ***\n");
	printf("*** 4. Buscar una persona					    ***\n");
        printf("*** 5. Ordenar de mayor a menor edad                                ***\n");
        printf("*** 6. Ordenar de mayor a menor estatura                            ***\n");
	printf("*** 7. Grabar los datos en un fichero				    ***\n");
	printf("*** 8. Recuperar datos de un fichero binario			    ***\n");
	printf("*** 9. Salir							    ***\n");
	printf("*** --------------------------------------------------------------- ***\n");
	printf("***********************************************************************\n");
	printf("\n\nElige una opcin: ");
	scanf("%d",&opc);
	fflush(stdin);
        }while(opc<1 || opc>9);
return opc;
}



/* Funcion Reserva */
/* reserva memoria para el puntero datos */
/* es de tipo entero, devuelve 1 si no hay errores y -1 si los hay */
/* recibe un puntero a estructura datos_persona y un entero, que es el numero de
personas */


int Reserva(struct datos_persona **datos,int n)
{
*datos=(struct datos_persona*)malloc(n*sizeof(struct datos_persona));
if(datos==NULL)
  return -1;
return 1;
}


/* funcion LeerTeclado */
/* introduce en el puntero datos los datos de las personas */
/* es de tipo void, no devuelve nada */
/* recibe un puntero a estructura datos_persona llamado *datos, y un 
entero n,que es el numero de personas que se van a introducir */

void LeerTeclado(struct datos_persona *datos,int n)
{
int i;
for(i=0;i<n;i++)
	{
	printf("\nPersona nmero %d:\n\n",i+1);
	printf("Nombre: ");
	
	scanf("%s",&datos[i].nombre);
	printf("Primer apellido: ");
	scanf("%s",&datos[i].apellido1);
	printf("Segundo apellido: ");
	scanf("%s",&datos[i].apellido2);
	printf("Nif: ");
	scanf("%s",&datos[i].nif);
        fflush(stdin);
	printf("Edad: ");
	scanf("%d",&datos[i].edad);
        fflush(stdin);
	printf("Peso: ");
	scanf("%d",&datos[i].peso);
        fflush(stdin);
	printf("Estatura: ");
	scanf("%d",&datos[i].estatura);
        fflush(stdin);
	}
}

/* Funcin Listar */
/* realiza un listado por pantalla de todas las personas del vector */
/* es de tipo void y no devuelve nada, recibe un puntero a estructura de 
datos_personas, para recoger los datos del vector y n un entero que es el numero
de personas del vector */

void Listar(struct datos_persona *datos,int n)
{
int i;
system("clear");
printf("LISTADO DE LAS PERSONAS PERTENECIENTES A LA LISTA\n");
printf("-------------------------------------------------------------------------------\n\n");
for(i=0;i<n;i++)
	{
	printf("\nPersona nmero: %d\n",i+1);
	printf("---------------------\n");
	printf("Nombre: %s %s %s.\n",datos[i].nombre,datos[i].apellido1,datos[i].apellido2);
	printf("Nif: %s NIF.\n",datos[i].nif);
	printf("Edad: %d aos.\n",datos[i].edad);
	printf("Peso: %d kg.\n",datos[i].peso);
	printf("Estatura: %d cm.\n",datos[i].estatura);
	printf("---------------------\n\n");
	printf("Pulsa ENTRAR para continuar...");
	getchar();
	}
printf("Listado de personas terminado.\n");
printf("Pulse ENTRAR para continuar...\n");
getchar();
}


/* Funcin BusquedaDicotomica */
/* es de tipo entero, realiza la busqueda de una persona en el vector y devuelve el indice
del elemento, si no se encontrase devolveria -1 */
/* recibe un puntero a estructura de datos_persona, *datos, y un entero n que es
el numero de personas que se encuentran en el vector */

int BusquedaDicotomica(struct datos_persona *datos,int n,char *apellido)
{
int lugar,mitad,inferior=0,superior=n-1,inicial=inferior,final=superior;
while(inferior<superior)
	{
	mitad=(inferior+superior)/2;
	if(strcmp(datos[mitad].apellido1,apellido)<0)
		inferior=mitad+1;
	else
		superior=mitad;
	}
if(strcmp(datos[inferior].apellido1,apellido)==0)
	return inferior;	/* Ha sido encontrado y devuelve el lugar */
else
	return -1;		/* No ha sido encontrado y devuelve -1 */
}
